<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="formModel"
            :hidden-data="{
                id: formModel.id,
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const statusOptions = ref([]);

const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'name',
            label: $i18n.t('name'),
            readonly: true,
            disabled: true
        },
        {
            type: 'text',
            name: 'ext',
            label: $i18n.t('ext'),
        },
        {
            type: 'text',
            name: 'currency_prefix',
            label: $i18n.t('currency'),
        },
        {
            type: 'text',
            name: 'conversion_rate',
            label: $i18n.t('conversion_rate'),
            fund: true
        },
        {
            type: 'select',
            name: 'status',
            label: $i18n.t('status'),
            placeholder: $i18n.t('please_select'),
            options: statusOptions.value
        },
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/other/country/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/other/country/build_form', {
            id: props.formModel ? props.formModel.id : '',
        });

        if (data.model) {
            model.value = data.model;
        }

        if (data.status) {
            statusOptions.value = Object.keys(data.status).map(key => {
                return {
                    value: String(key),
                    text: data.status[key],
                };
            });
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
